<template>
  <button
    class="bk8-btn" :style="`--bk8-btn-bg: ${usePrimaryColor ? 'var(--background3)' : 'var(--background2)'}` "
    :class="{ active: isActive }"
    @click="$emit('click')"
  >
    <div class="bk8-btn__container" :with-text="text && text.length > 0">
      <img :class="['ml-4', usePrimaryColor ? 'bk8-btn__logo_primary' : 'bk8-btn__logo']" :src="logo" />
      <div :class="usePrimaryColor ? 'bk8-btn__text_primary' : 'bk8-btn__text'">
        {{capitalizeEveryWord(text)}}
      </div>
    </div>
    <span class="bk8-btn__tag" v-if="isHot">hot</span>
    <span class="bk8-btn__tag__new" v-if="isNew && !isHot">new</span>
    <slot name="right"></slot>
  </button>
</template>

<script setup lang="ts">
defineEmits(["click"]);
defineProps({
  enableTags: {
    type: Boolean,
    required: false,
    default: () => true,
  },
  isHot: {
    type: Boolean,
    required: false,
    default: () => false,
  },
  isNew: {
    type: Boolean,
    required: false,
    default: () => false,
  },
  logo: {
    type: String,
    required: false,
    default: "",
  },
  text: {
    type: String,
    required: false,
    default: "",
  },
  isActive: {
    type: Boolean,
    required: false,
    default: false,
  },
  usePrimaryColor: {
    type: Boolean,
    default: false,
  },
});
const capitalizeEveryWord = (text:string) => {
  if (!text) return text;
  const regex = /\(([^)]+)\)|\b\w+\b/g;
  return text.replace(regex, (match, group1) => {
    if (group1) {
      return `(${group1.toUpperCase()})`; // capitalize words inside parentheses
    } else if (/^\d/.test(match)) {
      return match; // preserve original case of words that start with a digit
    } else {
      return match.charAt(0) + match.slice(1);
    }
  }).replace(/^\w|\s\w/g, (match) => {
    return match.toUpperCase();
  });
}
</script>
<style>
:root {
  --bk8-btn-width: 143px;
  --bk8-btn-color: var(--selected);
  --bk8-btn-bg: var(--background2);
  --bk8-border-radius: 4px;
  --bk8-bar-position: translateX(50%);
}
</style>

<style scoped lang="scss">
:deep(.bk8-btn::before),
:deep(.bk8-btn::after),
:deep(.bk8-btn *::before),
:deep(.bk8-btn *::after) {
  --bk8-btn-width: var(--bk8-btn-width: );
  --bk8-btn-color: var(--bk8-btn-color);
  --bk8-btn-bg: var(--bk8-btn-bg);
  --bk8-border-radius: var(--bk8-border-radius);
  --bk8-bar-position: var(--bk8-bar-position);
}
.bk8-btn {
  aspect-ratio: 2.55;
  background-color: var(--bk8-btn-bg);
  position: relative;
  display: flex;
  align-items: center;
  color: var(--text2);
  transition: all 0.4s;
  width: 152px;
  height: 40px;
  border-radius: 32px;
}

.bk8-btn:hover,
.bk8-btn:focus,
.bk8-btn.active {
  transform: translateY(-10%);
  border: 1px solid var(--selected);
}
.bk8-btn:hover::after,
.bk8-btn:focus::after,
.bk8-btn.active::after {
  opacity: 0;
}

.bk8-btn__container {
  width: 100%;
  height: 100%;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  overflow: hidden;
}

.bk8-btn__logo {
  width: 24px;
  height: 24px;
  filter: var(--text2-filter);
}
.bk8-btn__logo_primary {
  width: 24px;
  height: 24px;
}
.bk8-btn.active .bk8-btn__logo,
.bk8-btn:hover .bk8-btn__logo,
.bk8-btn:active .bk8-btn__logo {
  filter: var(--primary-filter);
}
.bk8-btn.active .bk8-btn__logo_primary,
.bk8-btn:hover .bk8-btn__logo_primary,
.bk8-btn:active .bk8-btn__logo_primary {
  filter: var(--selected-filter);
}
.bk8-btn__bottom {
  position: absolute;
  width: 100%;
  height: 11%;
  left: 0;
  bottom: 0;
  overflow: hidden;
}

.bk8-btn__bottom-bar {
  width: 100%;
  height: 100%;
  position: relative;
}

.bk8-btn__bottom-bar::before {
  content: "";
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  height: 50%;
  background-color: var(--bk8-btn-color);
  border-bottom-left-radius: var(--bk8-border-radius);
  border-bottom-right-radius: var(--bk8-border-radius);
}

.bk8-btn__bottom-bar::after {
  content: "";
  position: absolute;
  bottom: 42%;
  left: 0;
  width: 50%;
  height: 50%;
  transform: var(--bk8-bar-position);
  background-color: var(--bk8-btn-color);
  border-top-left-radius: var(--bk8-border-radius);
  border-top-right-radius: var(--bk8-border-radius);
}
.bk8-btn__tag, .bk8-btn__tag__new {
  position: absolute;
  width: 40px;
  height: 16px;
  display: flex;
  align-items: center;
  justify-content: center;
  font-weight: 500;
  font-size: 10px;
  line-height: 12px;
  text-align: center;
  text-transform: capitalize;
  color: var(--textBtn);
  border-radius: 8px;
  left: 108px;
  top: -8px;
}
.bk8-btn__tag {
  background-color: var(--bk8-btn-color);
}
.bk8-btn__tag__new {
  background-color: var(--tertiary);
}
.bk8-btn__text, .bk8-btn__text_primary {
  font-weight: 700;
  font-size: 12px;
  line-height: 14px;
  text-align: start;
  color: var(--text2);
  width: 100%;
  padding: 0 0.25rem;
  height: 100%;
  display: flex;
  align-items: center;
  word-break: break-word;
}
.bk8-btn__text:hover, .bk8-btn__text_primary:hover {
  animation-play-state: paused;
}
@keyframes floatText {
  to {
    transform: translateX(-100%);
  }
}
.bk8-btn:hover .bk8-btn__text,
.bk8-btn:focus .bk8-btn__text,
.bk8-btn.active .bk8-btn__text {
  color: var(--text);
}
.bk8-btn:hover .bk8-btn__text_primary,
.bk8-btn:focus .bk8-btn__text_primary,
.bk8-btn.active .bk8-btn__text_primary {
  color: var(--primary);
}
</style>
